
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Basic language features}
    
% \begin{itemize}[<+->]
%     \item Sceleton
% \end{itemize}

\begin{columns}
\begin{column}{0.6\textwidth}
  
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
program my_program

  implicit none

  ! (global) variables
  char(len=20) director = "Angel"


  ! let's do something
  call say_hello_to(director)


contains

  subroutine say_hello_to(name)
    char(*), intent(in) :: name

    write(*,*) "Hello ", name
  end subroutine say_hello_to

end program my_program
\end{lstlisting}
}
\end{column}
\begin{column}{0.4\textwidth}
  \begin{itemize}[<+->]
    \item Don't omit! \\[2mm]
    \item Variable definitions \\[2mm]
    \item Main program \\[1cm]
    \item subprogram definitions\\[1cm]
  \end{itemize}
  \vspace*{5mm}
\end{column}
\end{columns}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame}[fragile] \frametitle{Modules}
  
  In more complicated programs, move definitions of functions, classes, etc. into module files. \\[5mm]

  \begin{columns}
  \begin{column}{0.55\textwidth}
  {\tt main.F90:}
  {\tiny
\lstset{language=Fortran}
\begin{lstlisting}
program my_program

  use greetings_mod
  implicit none

  ! (global) variables
  char(len=20), dimension(3) :: directors = &
               ["Angel", "Andrea", "Phillip"]
  integer :: index

  ! let's do something
  do index=1, size(directors)
    call say_hello_to(director[i])
  end do

end program my_program
\end{lstlisting}
}
\end{column}

  \begin{column}{0.45\textwidth}
{\tt module.F90:}
{\tiny
\lstset{language=Fortran}
\begin{lstlisting}
module greeting_mod

  implicit none

  private
  public :: say_hello_to

contains

  subroutine say_hello_to(name)
    char(*), intent(in) :: name

    write(*,*) "Hello ", name
  end subroutine say_hello_to

end module greetins_mod
\end{lstlisting}
}
\end{column}
  \end{columns}
  
  \end{frame}
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Compiling and linking}

  \begin{itemize}[<+->]
  \item Fortran is a compiled language
  \item Need to translate the program text into machine code
  \item Compilation:
  \begin{itemize}
    \item Translate into "Object code"
  \end{itemize} 
  \item Linking
  \begin{itemize}
    \item Combine objects into executable code
  \end{itemize} 
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Compiling and linking: examples}

\begin{itemize}
  \item Single file code
  \begin{verbatim}
    gfortran -o executable program.F90
  \end{verbatim}

  \item Code with modules (in one command)
  \begin{verbatim}
    gfortran -o executable module.F90 program.F90
  \end{verbatim}

  \item Code with modules (seperate compilation)
  \begin{verbatim}
    gfortran -c module.F90 
    gfortran -c program.F90
    gfortran -o executable module.o program.o
  \end{verbatim}
\end{itemize}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Build systems}

  \begin{itemize}[<+->]
  \item Bigger projects contain hundrets of files
  \item Some files depend on other files (e.g. dependence on modules)
  \item Compilation needs to be in the right order \\[1cm]
  
  \item Build systems
  \begin{itemize}
    \item {\tt make}: {\tt Makefile}
    \item {\tt ninja}: {\tt build.ninja}
  \end{itemize} 
  \item System to configure the project and create the Makefile or ninja files
  \begin{itemize}
    \item {\tt autotools}
    \item {\tt CMake}
  \end{itemize} 
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{frame}[fragile] \frametitle{Minimal CMake example}

Configuration in {\tt CmakeList.txt}

{\tiny
\lstset{language=Python}
\begin{lstlisting}
  # set minimum cmake version
  cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
  
  # project name and language
  project(Integration LANGUAGES Fortran)
  
  add_executable(integration functions.F90 integrators.F90 integration.F90)
\end{lstlisting}
}

Building in {\tt CmakeList.txt}
  
{\tiny
\lstset{language=Python}
\begin{lstlisting}

cmake -B <build folder>

cmake --build <build folder>

\end{lstlisting}
}

For more details, see \\[5mm]
\url{https://gitlab.com/octopus-code/octopus/-/blob/main/cmake/README.md?ref_type=heads}

\end{frame}
